package com.gx.obe.evaluation.step.composite.boq;

import java.util.List;

import org.eclipse.nebula.widgets.grid.Grid;
import org.eclipse.nebula.widgets.grid.GridColumn;
import org.eclipse.nebula.widgets.grid.GridItem;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;

import com.gx.obe.evaluation.step.inter.IDwgcDetail;
import com.gx.obe.util.utils.LogUtils;
import com.gx.obe.util.utils.ObjectUtils;
import com.gx.obe.web.entity.boq.ConstructProject;
import com.gx.obe.web.entity.boq.ProvisionalSums;
import com.gx.obe.web.service.boq.ProvisionalSumsService;

/** 
 * @Description: 其它项目暂列金额明细
 * @author guoyr 
 */
public class OtherItemZljeComposite extends Composite implements IDwgcDetail{

	{
		LogUtils.logClass(OtherItemZljeComposite.class);
	}
	private Grid itemGrid;
	private ProvisionalSumsService provisionalSumsService = new ProvisionalSumsService();

	/**
	 * Create the composite.
	 * @param parent
	 * @param style
	 */
	public OtherItemZljeComposite(Composite parent, int style) {
		super(parent, style);
		GridLayout gridLayout = new GridLayout(1, false);
		gridLayout.marginHeight = 0;
		gridLayout.marginWidth = 0;
		setLayout(gridLayout);
		
		itemGrid = new Grid(this, SWT.H_SCROLL | SWT.V_SCROLL);
		itemGrid.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		itemGrid.setHeaderVisible(true);
		
		GridColumn gridColumn = new GridColumn(itemGrid, SWT.NONE);
//		gridColumn.setShowTreeTogglePic(false);
		gridColumn.setTree(true);
		gridColumn.setText("序号");
		gridColumn.setWidth(60);
		gridColumn.setMaxmumWidth(60);
		
		GridColumn nameColumn = new GridColumn(itemGrid, SWT.NONE);
		nameColumn.setText("名称");
		nameColumn.setWidth(150);
		
		GridColumn gridColumn_1 = new GridColumn(itemGrid, SWT.CENTER);
		gridColumn_1.setText("单位");
		gridColumn_1.setWidth(80);
		
		GridColumn gridColumn_2 = new GridColumn(itemGrid, SWT.RIGHT);
		gridColumn_2.setText("合价");
		gridColumn_2.setWidth(100);
		
		GridColumn gridColumn_3 = new GridColumn(itemGrid, SWT.NONE);
		gridColumn_3.setText("备注");
		gridColumn_3.setWidth(150);
		gridColumn_3.setWordWrap(true);
		
		GridItem gridItem = new GridItem(itemGrid, SWT.NONE);
		gridItem.setText("New Row");
		
		init();
	}
	
	/**
	 * @Description:  初始化界面
	 * @author guoyr
	 */
	private void init(){
		itemGrid.setItemHeight(25);
		itemGrid.setAutoHeight(true);
	}
	
	/**
	 * @Description:  刷新暂列金额
	 * @author guoyr
	 * @param xmlResolver
	 * @param dxgcCode
	 * @param dwgcCode
	 */
	public void refreshDetail(ConstructProject unitConstructProject){
		itemGrid.removeAll();
		if(null != unitConstructProject){
			
			// 在单位工程下获得暂列金额
			List<ProvisionalSums> topProvisionalSums = provisionalSumsService.getProvisionalSumsListByProjectId(unitConstructProject.getId());
//			GridItem zljeItem = new GridItem(itemGrid, SWT.NONE);
//			zljeItem.setImage(0, ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/sum.png"));
//			zljeItem.setText(1, "暂列金额合计");
			
			if(null != topProvisionalSums){
				for(ProvisionalSums provisionalSums : topProvisionalSums){
					GridItem gridItem = new GridItem(itemGrid, SWT.NONE);
					gridItem.setText(0, ObjectUtils.getObjString(provisionalSums.getProvisionalCode()));
					setRowContent(gridItem, provisionalSums);
				}				
			}
		}
	}
	/**
	 * @Description:  设置每行的内容
	 * @author guoyr
	 * @param gridItem
	 * @param extraTable
	 */
	private void setRowContent(GridItem gridItem, ProvisionalSums extraTable){
		gridItem.setText(1,ObjectUtils.getObjString(extraTable.getProvisionalName()));
		gridItem.setText(2,ObjectUtils.getObjString(extraTable.getUnit()));
		gridItem.setText(3,ObjectUtils.getObjString(extraTable.getTotal()));
		gridItem.setText(4,ObjectUtils.getObjString(extraTable.getRemark()));
	}
	public Composite getComposite(){
		return this;
	}

	protected void checkSubclass() {
	}
}
