package com.gx.obe.evaluation.step.composite.struct;

import org.eclipse.swt.widgets.Composite;

import com.gx.obe.components.core.Constants;
import com.gx.obe.evaluation.step.inter.IServiceFactory;
import com.gx.obe.evaluation.step.listener.ExpertEvaluationListener;
import com.gx.obe.web.entity.auth.AuthUser;
import com.gx.obe.web.entity.evaluation.EvaluationStep;
import com.gx.obe.web.entity.expert.Expert;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.entity.tender.TenderProjectRuleEntity;

/** 
 * @Description: 评审视图
 * @author chenxw 
 */
public class EvaluationView extends Composite implements IServiceFactory {
	
	protected TenderProjectEntity curTender;
	protected TenderProjectRuleEntity curRule;
	protected EvaluationStep curStep;
	protected Expert curExpert;
	protected AuthUser curUser;
	
	protected ExpertEvaluationListener expertEvaluationListener;
	
	public EvaluationView(Composite parent, int style) {
		super(parent, style);
		
		this.curTender = (TenderProjectEntity) parent.getData("tenderProjectEntity");
		this.curRule = (TenderProjectRuleEntity) parent.getData("tenderProjectRuleEntity");
		this.curStep = (EvaluationStep) parent.getData("evaluationStep");
		this.curExpert = (Expert) parent.getData(Constants.CUR_EXPERT);
		this.curUser = Constants.USER;
	}
	
	public void addExpertEvaluationListener(ExpertEvaluationListener expertEvaluationListener) {
		this.expertEvaluationListener = expertEvaluationListener;
	}
	
}
