package com.gx.obe.evaluation.step.form;

import java.math.BigDecimal;
import java.text.MessageFormat;
import java.text.NumberFormat;
import java.util.ArrayList;
import java.util.List;

import org.eclipse.nebula.widgets.grid.Grid;
import org.eclipse.nebula.widgets.grid.GridColumn;
import org.eclipse.nebula.widgets.grid.GridItem;
import org.eclipse.nebula.widgets.grid.listener.GridCheckedListener;
import org.eclipse.swt.SWT;
import org.eclipse.swt.core.CallBack;
import org.eclipse.swt.core.ImageResolver;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.core.listener.TextHintListener;
import org.eclipse.swt.core.listener.VerifyDigitListener;
import org.eclipse.swt.core.listener.VerifyRequiredListener;
import org.eclipse.swt.core.utils.ValidateUtils;
import org.eclipse.swt.core.utils.WidgetUtils;
import org.eclipse.swt.core.widgets.EButton;
import org.eclipse.swt.core.widgets.EDialog;
import org.eclipse.swt.core.widgets.ESepator;
import org.eclipse.swt.custom.CLabel;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import com.gx.obe.ColorConstants;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.common.widget.button.Tips;
import com.gx.obe.components.core.I18NEnum;
import com.gx.obe.components.core.enumeration.CommonEnum;
import com.gx.obe.components.core.enumeration.EvaluationFactorEnum;
import com.gx.obe.components.core.enumeration.EvaluationStepEnum;
import com.gx.obe.config.utils.PropertiesUtils;
import com.gx.obe.message.Messages;
import com.gx.obe.util.utils.BigDecimalUtils;
import com.gx.obe.util.utils.LogUtils;
import com.gx.obe.util.utils.ObjectUtils;
import com.gx.obe.util.utils.StringUtils;
import com.gx.obe.web.entity.evaluation.EvaluationFactor;
import com.gx.obe.web.entity.evaluation.EvaluationStep;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.service.evaluation.EvaluationFactorService;
import com.gx.obe.web.service.evaluation.EvaluationStepFactorService;
import com.gx.obe.web.service.evaluation.EvaluationStepService;
import org.eclipse.swt.core.utils.GridUtils;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

/**
 * @Description: 综合信用评审
 * @author guoyr
 */
public class CreditEvaluationStepDialog extends EDialog {
	
	private Text stepNameText;
	private Composite roleTypeComposite;
	private EButton save_btn;
	private ImageResolver imageResolver = new ImageResolver();
	private EvaluationStepService evaluationStepService = new EvaluationStepService();
	private EvaluationStepFactorService evaluationStepFactorService;
	private EvaluationFactorService evaluationFactorService = new EvaluationFactorService();
	private TenderProjectEntity tenderProjectEntity;
	private EvaluationStep evaluationStep;
	private Grid grid;
	private GridColumn gridColumn;
	private Image menuOpenImage;
	private Image menuImage;
	private Text stepMemoText;
	private Composite composite;
	private CallBack callBack;
	private Button button_2;
	private Button button_3;
	private boolean isInEvaluation = false;// 是否在评审中
	private Tips messageRabel;
	private List<Object> factorList;
	private GridItem topGridItem;
	private Text creditSourceNameText;
	private Text creditFullScoreText;
	private Label scoreAndWeight;
	
	{
		LogUtils.logClass(CreditEvaluationStepDialog.class);
	}

	/**
	 * Create the dialog.
	 * @param parentShell
	 */
	public CreditEvaluationStepDialog(Shell parentShell, TenderProjectEntity tenderProjectEntity, EvaluationStep evaluationStep) {
		super(parentShell);
		setTitle(Messages.Step_step);
		this.tenderProjectEntity = tenderProjectEntity;
		this.evaluationStep = evaluationStep;
	}

	/**
	 * Create contents of the dialog.
	 * @param parent
	 */
	@Override
	protected Control createDialogArea(Composite parent) {
		Composite topContainer = (Composite) super.createDialogArea(parent);
		topContainer.addDisposeListener(new DisposeListener() {
			public void widgetDisposed(DisposeEvent e) {
				imageResolver.disposite();
			}
		});
		GridLayout gl_topContainer = new GridLayout(1, false);
		gl_topContainer.verticalSpacing = 0;
		gl_topContainer.horizontalSpacing = 0;
		gl_topContainer.marginHeight = 0;
		gl_topContainer.marginWidth = 0;
		topContainer.setLayout(gl_topContainer);
		
		Composite container = new Composite(topContainer, SWT.NONE);
		container.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		GridLayout gl_container = new GridLayout(2, false);
		gl_container.marginHeight = 10;
		gl_container.marginWidth = 10;
		container.setLayout(gl_container);
		this.setOperator(SWT.MAX|SWT.CLOSE);
		
		messageRabel = new Tips(container, SWT.WRAP);
		messageRabel.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 2, 1));
		messageRabel.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, EvaluationStepEnum.getEvaluationStepIco(EvaluationStepEnum.CREDIT)));
		messageRabel.setSurroundColor(SWTResourceManager.getColor(60, 138, 226));
		
		composite = new Composite(container, SWT.NONE);
		GridLayout gl_composite = new GridLayout(2, false);
		gl_composite.marginWidth = 0;
		composite.setLayout(gl_composite);
		GridData gd_composite = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1);
		gd_composite.widthHint = 414;
		composite.setLayoutData(gd_composite);
		
		Label label = new Label(composite, SWT.NONE);
		label.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		label.setText(Messages.StepName + ": ");
		
		Composite composite_2 = new Composite(composite, SWT.NONE);
		composite_2.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		GridLayout gl_composite_2 = new GridLayout(2, false);
		gl_composite_2.marginWidth = 0;
		gl_composite_2.verticalSpacing = 1;
		gl_composite_2.marginHeight = 0;
		composite_2.setLayout(gl_composite_2);
		
		stepNameText = new Text(composite_2, SWT.NONE);
		stepNameText.setFont(SWTResourceManager.getFont("微软雅黑", 9, SWT.NORMAL));
		stepNameText.setLayoutData(new GridData(SWT.FILL, SWT.BOTTOM, true, false, 1, 1));
		stepNameText.addPaintListener(new TextHintListener(Messages.Tips_EnterEvaluationStepName));
		stepNameText.addVerifyListener(new VerifyRequiredListener(stepNameText, MessageFormat.format(Messages.Tips_required, Messages.StepName)));
		stepNameText.setTextLimit(20);
		stepNameText.setText("");
		stepNameText.setText(com.gx.obe.components.core.I18N.getString(I18NEnum.COMPLIANCE_EVALUATION));
		
		scoreAndWeight = new Label(composite_2, SWT.NONE);
		scoreAndWeight.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		scoreAndWeight.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		scoreAndWeight.setText("");
		
		ESepator namSep = new ESepator(composite_2, SWT.NONE);
		namSep.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 2, 1));
		namSep.setBackground(ColorConstants.SEP_LIGHT_COLOR);
		
		Label label_1 = new Label(composite, SWT.NONE);
		label_1.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		label_1.setText(Messages.EvaluationMembers + "：");
		
		Composite composite_6 = new Composite(composite, SWT.NONE);
		composite_6.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		GridLayout gl_composite_6 = new GridLayout(1, false);
		gl_composite_6.marginHeight = 0;
		gl_composite_6.verticalSpacing = 1;
		gl_composite_6.marginWidth = 0;
		composite_6.setLayout(gl_composite_6);
		
		roleTypeComposite = new Composite(composite_6, SWT.NONE);
		roleTypeComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		GridLayout gl_roleTypeComposite = new GridLayout(2, false);
		gl_roleTypeComposite.marginHeight = 0;
		gl_roleTypeComposite.marginWidth = 0;
		roleTypeComposite.setLayout(gl_roleTypeComposite);
		
		button_3 = new Button(roleTypeComposite, SWT.RADIO);
		button_3.setText(Messages.ExpertLeader);
		button_3.setData("roleType", EvaluationStepEnum.EXPERT_LEADER);
		button_3.setSelection(true);
		
		button_2 = new Button(roleTypeComposite, SWT.RADIO);
		button_2.setText(Messages.ProjectManager);
		button_2.setData("roleType", EvaluationStepEnum.OPERATOR);
		
		Label label_2 = new Label(composite, SWT.NONE);
		label_2.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		label_2.setText("得分来源：");
		
		Composite composite_3 = new Composite(composite, SWT.NONE);
		GridLayout gl_composite_3 = new GridLayout(4, false);
		gl_composite_3.horizontalSpacing = 0;
		gl_composite_3.marginHeight = 0;
		gl_composite_3.marginWidth = 0;
		gl_composite_3.verticalSpacing = 0;
		composite_3.setLayout(gl_composite_3);
		composite_3.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		
		creditSourceNameText = new Text(composite_3, SWT.NONE);
		creditSourceNameText.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		creditSourceNameText.setText("信息网查询得分");
		
		Label label_3 = new Label(composite_3, SWT.NONE);
		label_3.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		label_3.setText("且满分为");
		
		creditFullScoreText = new Text(composite_3, SWT.NONE);
		creditFullScoreText.addVerifyListener(new VerifyDigitListener(true, "请输入正确的满分制！"));
		GridData gd_text_1 = new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1);
		gd_text_1.widthHint = 40;
		creditFullScoreText.setLayoutData(gd_text_1);
		creditFullScoreText.setText("   ");
		
		Label label_4 = new Label(composite_3, SWT.NONE);
		label_4.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		label_4.setText("分制。  ");
		
		ESepator creditSep = new ESepator(composite_3, SWT.NONE);
		creditSep.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 4, 1));
		creditSep.setBackground(ColorConstants.SEP_LIGHT_COLOR);
		
		CLabel label_5 = new CLabel(composite, SWT.NONE);
		label_5.setLayoutData(new GridData(SWT.RIGHT, SWT.TOP, false, true, 1, 1));
		label_5.setText(Messages.NodeNote + "：");
		
		stepMemoText = new Text(composite, SWT.BORDER | SWT.WRAP | SWT.V_SCROLL);
		stepMemoText.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		stepMemoText.setTextLimit(100);
		
		Composite table_border_composite = new Composite(container, SWT.NONE);
		table_border_composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, true, 1, 1));
		GridLayout gl_composite_5 = new GridLayout(1, false);
		gl_composite_5.marginHeight = 1;
		gl_composite_5.marginWidth = 1;
		table_border_composite.setLayout(gl_composite_5);
		table_border_composite.setBackground(ColorConstants.BORDER_LINE_COLOR);
		
		Composite table_composite = new Composite(table_border_composite, SWT.NONE);
		table_composite.setBackground(SWTResourceManager.getColor(255, 255, 255));
		table_composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		GridLayout gl_tab_composite_4 = new GridLayout(1, false);
		gl_tab_composite_4.marginWidth = 0;
		gl_tab_composite_4.marginBottom = 5;
		gl_tab_composite_4.marginHeight = 0;
		gl_tab_composite_4.verticalSpacing = 0;
		table_composite.setLayout(gl_tab_composite_4);
		
		grid = new Grid(table_composite, SWT.H_SCROLL | SWT.V_SCROLL);
		GridData gd_grid = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1);
		gd_grid.widthHint = 280;
		grid.setLayoutData(gd_grid);
		
		gridColumn = new GridColumn(grid, SWT.CHECK);
		gridColumn.setText("New Column");
		gridColumn.setWidth(150);
		
		topGridItem = new GridItem(grid, SWT.NONE);
		topGridItem.setText(PropertiesUtils.getEnum(I18NEnum.CREDIT_FACTOR, "综合信用")+"指标");
		topGridItem.setImage(0, menuOpenImage);
		topGridItem.setExpanded(true);
		
		ESepator but_sep = new ESepator(topContainer, SWT.SEPARATOR | SWT.HORIZONTAL);
		but_sep.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		but_sep.setBackground(ColorConstants.SEP_LIGHT_COLOR);
		
		Composite composite_1 = new Composite(topContainer, SWT.NONE);
		composite_1.setBackgroundMode(SWT.INHERIT_FORCE);
		composite_1.setBackgroundImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/fill_bg.png"));
		composite_1.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 3, 1));
		GridLayout gl_composite_1 = new GridLayout(2, false);
		composite_1.setLayout(gl_composite_1);
		
		save_btn = new EButton(composite_1, SWT.NONE);
		save_btn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/save.png"));
		GridData gd_confirmBtn = new GridData(SWT.RIGHT, SWT.CENTER, true, false, 1, 1);
		gd_confirmBtn.widthHint = 90;
		save_btn.setLayoutData(gd_confirmBtn);
		save_btn.setText(Messages.Button_save);
		save_btn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				saveNodeAction();
			}
		});
		EButton cancel_btn = new EButton(composite_1, SWT.NONE);
		cancel_btn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/close.png"));
		cancel_btn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				cancelAction();
			}
		});
		GridData gd_button = new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1);
		gd_button.widthHint = 90;
		cancel_btn.setLayoutData(gd_button);
		cancel_btn.setText(Messages.Button_close);

		init();
		return container;
	}

	/**
	 * @Description: 初始化
	 * @author guoyr
	 */
	private void init(){
		evaluationStepFactorService = new EvaluationStepFactorService();
		String supplierName = com.gx.obe.components.core.I18N.getString(I18NEnum.SUPPLIERNAME, tenderProjectEntity.getTenderType());
		messageRabel.setText(MessageFormat.format(Messages.Tips_factorStep, Messages.Factor_credit));
		if(null == evaluationStep){
			evaluationStep = new EvaluationStep();
			evaluationStep.setStepName(PropertiesUtils.getEnum(I18NEnum.CREDIT_FACTOR, "综合信用"));
			evaluationStep.setFilterType(EvaluationStepEnum.FILTER_YES);
			evaluationStep.setPassType(EvaluationStepEnum.PASS_ALL);
			evaluationStep.setRoleType(EvaluationStepEnum.EXPERT_LEADER);
			evaluationStep.setStepStatus(CommonEnum.NOT_START);
			int maxSortNo = evaluationStepService.getMaxEvaluationStepSortNo(tenderProjectEntity.getId());
			evaluationStep.setSortNo(maxSortNo + 1);
			this.setTitle(MessageFormat.format(Messages.Title_create, Messages.Step_step));
		}else {
			this.setTitle(MessageFormat.format(Messages.Title_edit, Messages.Step_step));
			if(ObjectUtils.equals(evaluationStep.getStepStatus(), CommonEnum.COMPLETE)){
				composite.setEnabled(false);
				save_btn.setEnabled(false);
				isInEvaluation = true;
			}else {
				isInEvaluation = evaluationStepService.isInEvaluationStep(tenderProjectEntity.getId(), evaluationStep.getId());
			}
			if(isInEvaluation){
				roleTypeComposite.setEnabled(false);
			}
		}
		refreshEvaltionNodeForm();
		
		grid.setAutoHeight(true);
		gridColumn.setWordWrap(true);
		gridColumn.setShowTreeTogglePic(true);
		gridColumn.setTreeTogglePic(ImageResolver.RESOLVER_INSTANCE.loadImage(IconsActivator.PLUGIN_ID,"icons/tree_expend.png"), ImageResolver.RESOLVER_INSTANCE.loadImage(IconsActivator.PLUGIN_ID,"icons/tree_close.png"));
		gridColumn.setTree(true);
		menuOpenImage = imageResolver.loadImage(IconsActivator.PLUGIN_ID,"icons/tree_parent.png");
		menuImage = imageResolver.loadImage(IconsActivator.PLUGIN_ID,"icons/tree_item.png");
		refreshFactorTree();
		// 添加选中监听事件
		grid.addListener(SWT.Selection, new GridCheckedListener(false));
		GridUtils.refreshGridCheckedStatus(grid, 0);
		grid.addListener(SWT.Selection, new Listener(){
			public void handleEvent(Event event) {
				// 选中了复选框事件
				if(event.detail == SWT.CHECK){
					checkFactorItemAction();
				}
			}
		});
	}
	
	/**
	 * @Description: 显示分值和权重
	 * @author guoyr
	 * @param score
	 * @param weight 
	 */
	private void showScoreAndWeight(BigDecimal score, BigDecimal weight){
		if(null != score){
			if(null != weight && (weight.compareTo(BigDecimal.ZERO) == 0 || weight.compareTo(new BigDecimal(100)) == 0)){
				weight = null;
			}
			scoreAndWeight.setText(NumberFormat.getInstance().format(score) + "分"+(null !=  weight ? " （" + (NumberFormat.getInstance().format(weight)) +"%）": ""));
		}else {
			scoreAndWeight.setText("0分");
		}
		evaluationStep.setScore(score);
		evaluationStep.setWeight(weight);
		scoreAndWeight.getParent().layout();
	}
	
	/**
	 * @Description: 选择指标事件
	 * @author guoyr
	 * @param gridItem 
	 */
	private void checkFactorItemAction(){
		BigDecimal score = null;
		BigDecimal weight = null;
		if(null != topGridItem && !topGridItem.isDisposed()){
			
			List<EvaluationFactor> checkedTopFactorList = new ArrayList<EvaluationFactor>();
			for(GridItem topItem : topGridItem.getItems()){
				if(topItem.getCheckVisible(0) && topItem.getChecked(0)){
					EvaluationFactor topFactor = (EvaluationFactor)topItem.getData("evaluationFactor");
					checkedTopFactorList.add(topFactor);
				}
			}
			
			if(checkedTopFactorList.size() > 0){
				if(stepNameText.getText().length() == 0){
					String firstFactorName = checkedTopFactorList.get(0).getFactorName();
					stepNameText.setText(firstFactorName.length() > 9 ? firstFactorName.substring(0,9):firstFactorName);
				}
				for(EvaluationFactor topFactor : checkedTopFactorList){
					BigDecimal factorScore = topFactor.getFactorScore();
					BigDecimal factorWeight = topFactor.getFactorWeight();
					if(null != factorScore){
						score = null != score ? BigDecimalUtils.add(score, factorScore) : factorScore;
					}
					if(null != factorWeight){
						weight = null != weight ? BigDecimalUtils.add(weight, factorWeight) : factorWeight;
					}
				}
			}
		}
		showScoreAndWeight(score, weight);
	}
	
	/**
	 * @Description: 刷新评标步骤表单
	 * @author guoyr
	 */
	private void refreshEvaltionNodeForm(){
		stepNameText.setText(ObjectUtils.getObjString(evaluationStep.getStepName()));
		stepMemoText.setText(ObjectUtils.getObjString(evaluationStep.getStepMemo()));
		WidgetUtils.setRadioChecked(roleTypeComposite, ObjectUtils.getObjString(evaluationStep.getRoleType()), "roleType");
		String creditSourceName =  evaluationStep.getEvaluationParamByKey(EvaluationStepEnum.PARAM_CREDIT_SOURCE_NAME);
		String creditSourceFullScore = ObjectUtils.getObjString(evaluationStep.getEvaluationParamByKey(EvaluationStepEnum.PARAM_CREDIT_RATE));
		creditSourceNameText.setText(null != creditSourceName && creditSourceName.length() > 0 ? creditSourceName : PropertiesUtils.getProperty("creditSourceName", "信息网查询得分"));
		creditFullScoreText.setText(null != creditSourceFullScore && creditSourceFullScore.length() > 0 ? creditSourceFullScore : PropertiesUtils.getProperty("creditSourceFullScore", ""));
		showScoreAndWeight(evaluationStep.getScore(), evaluationStep.getWeight());
	}
	
	/**
	 * @Description: 刷新指标树
	 * @author guoyr
	 * @param factorId
	 */
	public void refreshFactorTree(){
		grid.removeAll();
		List<EvaluationFactor> scoreFactorList = evaluationFactorService.getFactorListOfEvaluationStep(tenderProjectEntity.getId(), EvaluationFactorEnum.AUDIT_CREDIT, evaluationStep.getId());
		List<EvaluationFactor> evaluationFactorList = new ArrayList<EvaluationFactor>();
		if(null != scoreFactorList){
			for(EvaluationFactor evaluationFactor : scoreFactorList){
//				if(null != evaluationFactor.getEvalBidType() && evaluationFactor.getEvalBidType().equals(EvaluationFactorEnum.EVAL_BID_CREDIT)){
//				}
				evaluationFactorList.add(evaluationFactor);
				// 目前只支持一个信用得分
				break;
			}
		}
		
		
		if(null != evaluationFactorList && evaluationFactorList.size() > 0){
			if(StringUtils.isNotEmpty(evaluationStep.getId())){
				factorList = evaluationStepFactorService.getFactorIdLsitByStepId(evaluationStep.getId());
			}
			topGridItem = new GridItem(grid, SWT.NONE);
			topGridItem.setText(PropertiesUtils.getEnum(I18NEnum.CREDIT_FACTOR, "综合信用")+"指标");
			topGridItem.setImage(0, menuOpenImage);
			topGridItem.setExpanded(true);
			if(isInEvaluation){
				topGridItem.setCheckVisible(0, false);
				topGridItem.setCheckable(0, false);
			}
			for(EvaluationFactor factor : evaluationFactorList){
				GridItem gridItem = new GridItem(topGridItem, SWT.NONE);
				gridItem.setText(0, factor.getFactorName());
				gridItem.setData("evaluationFactor", factor);
				if(isInEvaluation){
					gridItem.setCheckVisible(0, false);
					gridItem.setCheckable(0, false);
				}
//				gridItem.setCheckable(0, true);
				initChildGridItem(factor, gridItem);
			}
		}else {
			save_btn.setEnabled(false);
		}
		if(StringUtils.isNotEmpty(evaluationStep.getId())){
			GridUtils.refreshGridCheckedStatus(grid, 0);
		}else {
			GridUtils.checkAll(grid, 0, true);
		}
		checkFactorItemAction();
	}
	
	/**
	 * @Description: 递归实现指标树
	 * @author guoyr
	 * @param factor
	 * @param parentGridItem
	 * @param selectId
	 */
	private void initChildGridItem(EvaluationFactor factor, GridItem parentGridItem){
		if(null != factor.getChildFactorList() && factor.getChildFactorList().size() > 0){
			for(EvaluationFactor childFactor : factor.getChildFactorList()){
				GridItem gridItem = new GridItem(parentGridItem, SWT.NONE);
				gridItem.setText(0, childFactor.getFactorName());
				gridItem.setData("evaluationFactor", childFactor);
				gridItem.setCheckVisible(0, false);
				initChildGridItem(childFactor, gridItem);
			}
			parentGridItem.setExpanded(true);
			parentGridItem.setImage(0, menuOpenImage);
		}else {
			parentGridItem.setImage(0, menuImage);
		}
		if(null != factorList && factorList.contains(factor.getId())){
			parentGridItem.setChecked(0, true);
		}
	}
	
	
	/**
	 * @Description: 确定
	 * @author guoyr
	 */
	private void saveNodeAction(){
		if(save_btn.getEnabled()){
			if(!ValidateUtils.checkInput(stepNameText.getParent())){
				return;
			}
			// 验证评标步骤名称是否已经存在
			if(evaluationStepService.valEvaluationStepNameExist(tenderProjectEntity.getId(), evaluationStep.getId(), stepNameText.getText().trim())){
				MessageDialog.openWarning(getShell(), Messages.Step_step +"["+stepNameText.getText().trim()+"]" + Messages.Tips_AlreadyExistsPleaseRetype);
				stepNameText.setFocus();
				stepNameText.setSelection(stepNameText.getText().length());
				return;
			}
			evaluationStep.setEvaluationParam(EvaluationStepEnum.PARAM_CREDIT_SOURCE_NAME, creditSourceNameText.getText().trim());
			evaluationStep.setEvaluationParam(EvaluationStepEnum.PARAM_CREDIT_RATE,  ObjectUtils.getObjBigDecimal(creditFullScoreText.getText().trim()));
			PropertiesUtils.saveProperty("creditSourceName", creditSourceNameText.getText().trim());
			PropertiesUtils.saveProperty("creditSourceFullScore", creditFullScoreText.getText().trim());
			evaluationStep.setStepName(stepNameText.getText().trim());
			evaluationStep.setStepType(EvaluationStepEnum.CREDIT);
			evaluationStep.setStepMemo(stepMemoText.getText().trim());
			evaluationStep.setTenderId(tenderProjectEntity.getId());
			evaluationStep.setRoleType(ObjectUtils.getObjString(WidgetUtils.getRadioVal(roleTypeComposite,"roleType")));
			
			List<EvaluationFactor> checkedEvaluationFactorList = GridUtils.getRealCheckedValues(grid, 0, "evaluationFactor");
			List<String> factorWeightList = new ArrayList<String>();
			for(GridItem topItem : topGridItem.getItems()){
				if(topItem.getCheckVisible(0) && topItem.getChecked(0)){
					EvaluationFactor topFactor = (EvaluationFactor)topItem.getData("evaluationFactor");
					if(null != topFactor && null != topFactor.getFactorWeight()){
						factorWeightList.add(topFactor.getId());
					}
				}
			}
			
			if(null == checkedEvaluationFactorList || checkedEvaluationFactorList.size() == 0){
				MessageDialog.openWarning(getShell(), Messages.Tips_select+stepNameText.getText().trim()+"的评审指标！");
				return;
			}
			
			evaluationStep = (EvaluationStep) evaluationStepService.saveEvaluationStepAndFactors(evaluationStep, checkedEvaluationFactorList, factorWeightList, null);
			
			if(null != evaluationStep){
				if(null != callBack){
					callBack.callBackObject(evaluationStep);
				}
			}else {
				MessageDialog.openWarning(getShell(), stepNameText.getText()+Messages.Tips_saveFail);
			}
			this.getShell().close();
		}
	}
	
	/**
	 * @Description: 取消
	 * @author guoyr
	 */
	private void cancelAction(){
		this.getShell().close();
	}

	public CallBack getCallBack() {
		return callBack;
	}

	public void setCallBack(CallBack callBack) {
		this.callBack = callBack;
	}

	/**
	 * Return the initial size of the dialog.
	 */
	@Override
	protected Point getInitialSize() {
		return new Point(702, 493);
	}
}
