package com.gx.obe.evaluation.step.form;

import java.text.MessageFormat;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.CallBack;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.core.listener.TextHintListener;
import org.eclipse.swt.core.listener.VerifyRequiredListener;
import org.eclipse.swt.core.utils.ValidateUtils;
import org.eclipse.swt.core.utils.WidgetUtils;
import org.eclipse.swt.core.widgets.EButton;
import org.eclipse.swt.core.widgets.EDialog;
import org.eclipse.swt.core.widgets.ESepator;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import com.gx.obe.ColorConstants;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.common.widget.button.Tips;
import com.gx.obe.components.core.enumeration.CommonEnum;
import com.gx.obe.components.core.enumeration.EvaluationStepEnum;
import com.gx.obe.message.Messages;
import com.gx.obe.util.utils.LogUtils;
import com.gx.obe.util.utils.ObjectUtils;
import com.gx.obe.web.entity.evaluation.EvaluationStep;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.service.evaluation.EvaluationStepService;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

/**
 * @Description:
 * @author guoyr
 */
public class EditPriceStepDialog extends EDialog {
	
	private EvaluationStepService evaluationStepService = new EvaluationStepService();
	
	private Text stepNameText;
	private Composite roleTypeComposite;
	private Text stepMemoText;
	
	private EButton save_btn;
	
	private TenderProjectEntity tenderProjectEntity;
	private EvaluationStep evaluationStep;
	private CallBack callBack;
	
	private boolean isInEvaluation = false;// 是否在评审中
	
	{
		LogUtils.logClass(EditPriceStepDialog.class);
	}
	
	/**
	 * Create the dialog.
	 * 
	 * @param parentShell
	 */
	public EditPriceStepDialog(Shell parentShell, TenderProjectEntity tenderProjectEntity, EvaluationStep evaluationStep) {
		super(parentShell);
		this.tenderProjectEntity = tenderProjectEntity;
		this.evaluationStep = evaluationStep;
	}
	
	/**
	 * Create contents of the dialog.
	 * 
	 * @param parent
	 */
	@Override
	protected Control createDialogArea(Composite parent) {
		Composite topContainer = (Composite) super.createDialogArea(parent);
		GridLayout gl_topContainer = new GridLayout(1, false);
		gl_topContainer.verticalSpacing = 0;
		gl_topContainer.horizontalSpacing = 0;
		gl_topContainer.marginHeight = 0;
		gl_topContainer.marginWidth = 0;
		topContainer.setLayout(gl_topContainer);
		
		Composite container = new Composite(topContainer, SWT.NONE);
		container.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		GridLayout gl_container = new GridLayout(1, false);
		gl_container.marginHeight = 10;
		gl_container.marginWidth = 10;
		container.setLayout(gl_container);
		this.setOperator(SWT.MAX | SWT.CLOSE);
		
		Tips label_6 = new Tips(container, SWT.WRAP);
		label_6.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 3, 1));
		label_6.setText("");
		label_6.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, EvaluationStepEnum.getEvaluationStepIco(EvaluationStepEnum.PRICE)));
		label_6.setSurroundColor(SWTResourceManager.getColor(60, 138, 226));
		
		Composite composite = new Composite(container, SWT.NONE);
		GridLayout gl_composite = new GridLayout(2, false);
		gl_composite.verticalSpacing = 10;
		composite.setLayout(gl_composite);
		GridData gd_composite = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1);
		gd_composite.widthHint = 414;
		composite.setLayoutData(gd_composite);
		
		Label step_name = new Label(composite, SWT.NONE);
		step_name.setFont(SWTResourceManager.getFont("微软雅黑", 9, SWT.NORMAL));
		step_name.setAlignment(SWT.RIGHT);
		step_name.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		step_name.setText(Messages.StepName + ": ");
		
		Composite composite_2 = new Composite(composite, SWT.NONE);
		composite_2.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 1, 1));
		GridLayout gl_composite_2 = new GridLayout(1, false);
		gl_composite_2.marginWidth = 0;
		gl_composite_2.verticalSpacing = 1;
		gl_composite_2.marginHeight = 0;
		composite_2.setLayout(gl_composite_2);
		
		stepNameText = new Text(composite_2, SWT.NONE);
		stepNameText.setFont(SWTResourceManager.getFont("微软雅黑", 9, SWT.NORMAL));
		stepNameText.setLayoutData(new GridData(SWT.FILL, SWT.BOTTOM, true, false, 1, 1));
		stepNameText.addPaintListener(new TextHintListener(Messages.Tips_EnterEvaluationStepName));
		stepNameText.addVerifyListener(new VerifyRequiredListener(stepNameText,  MessageFormat.format(Messages.Tips_required, Messages.StepName)));
		stepNameText.setTextLimit(20);
		stepNameText.setText(Messages.Step_price);
		
		ESepator label = new ESepator(composite_2, SWT.NONE);
		label.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		label.setBackground(ColorConstants.SEP_LIGHT_COLOR);
		
		Label label_1 = new Label(composite, SWT.NONE);
		label_1.setFont(SWTResourceManager.getFont("微软雅黑", 9, SWT.NORMAL));
		label_1.setLayoutData(new GridData(SWT.RIGHT, SWT.TOP, false, false, 1, 1));
		label_1.setText(Messages.EvaluationMembers + "：");
		
		Composite composite_7 = new Composite(composite, SWT.NONE);
		composite_7.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		GridLayout gl_composite_7 = new GridLayout(1, false);
		gl_composite_7.marginHeight = 0;
		gl_composite_7.marginWidth = 0;
		gl_composite_7.verticalSpacing = 0;
		composite_7.setLayout(gl_composite_7);
		
		roleTypeComposite = new Composite(composite_7, SWT.NONE);
		roleTypeComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		GridLayout gl_roleTypeComposite = new GridLayout(2, false);
		gl_roleTypeComposite.marginHeight = 0;
		gl_roleTypeComposite.marginWidth = 0;
		roleTypeComposite.setLayout(gl_roleTypeComposite);
		
		Button all_expert = new Button(roleTypeComposite, SWT.RADIO);
		all_expert.setSelection(true);
		all_expert.setText(Messages.ExpertLeader);
		all_expert.setData("roleType", EvaluationStepEnum.EXPERT_LEADER);
		
		Button operator_expert = new Button(roleTypeComposite, SWT.RADIO);
		operator_expert.setData("roleType", EvaluationStepEnum.OPERATOR);
		operator_expert.setText(Messages.ProjectManager);
		
		Label label_5 = new Label(composite, SWT.NONE);
		label_5.setFont(SWTResourceManager.getFont("微软雅黑", 9, SWT.NORMAL));
		label_5.setLayoutData(new GridData(SWT.RIGHT, SWT.TOP, false, true, 1, 1));
		label_5.setText(Messages.Note + ": ");
		
		stepMemoText = new Text(composite, SWT.BORDER | SWT.WRAP | SWT.V_SCROLL);
		stepMemoText.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		stepMemoText.setTextLimit(100);
		
		ESepator but_sep = new ESepator(topContainer, SWT.SEPARATOR | SWT.HORIZONTAL);
		but_sep.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		but_sep.setBackground(ColorConstants.SEP_LIGHT_COLOR);
		
		Composite composite_1 = new Composite(topContainer, SWT.NONE);
		composite_1.setBackgroundMode(SWT.INHERIT_FORCE);
		composite_1.setBackgroundImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/fill_bg.png"));
		composite_1.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		GridLayout gl_composite_1 = new GridLayout(2, false);
		composite_1.setLayout(gl_composite_1);
		
		save_btn = new EButton(composite_1, SWT.NONE);
		save_btn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				saveEvaluationStepAction();
			}
		});
		GridData gd_confirmBtn = new GridData(SWT.RIGHT, SWT.CENTER, true, false, 1, 1);
		gd_confirmBtn.widthHint = 90;
		save_btn.setLayoutData(gd_confirmBtn);
		save_btn.setText(Messages.Button_save);
		save_btn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/save.png"));
		
		EButton cancel_btn = new EButton(composite_1, SWT.NONE);
		cancel_btn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				cancelAction();
			}
		});
		GridData gd_button = new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1);
		gd_button.widthHint = 90;
		cancel_btn.setLayoutData(gd_button);
		cancel_btn.setText(Messages.Button_close);
		cancel_btn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/close.png"));
		
		init();
		return container;
	}
	
	/**
	 * @Description: 初始化
	 * @author chenxw 
	 */
	private void init() {
		if (null == evaluationStep) {
			setTitle(MessageFormat.format(Messages.Title_create, Messages.Step_step));
			evaluationStep = new EvaluationStep();
			evaluationStep.setStepType(EvaluationStepEnum.EDIT_PRICE);//价格评审
			evaluationStep.setTenderId(tenderProjectEntity.getId());
			evaluationStep.setStepName("修正报价");
			evaluationStep.setStepStatus(CommonEnum.NOT_START);
			evaluationStep.setRoleType(EvaluationStepEnum.EXPERT_LEADER);
			evaluationStep.setFilterType(EvaluationStepEnum.FILTER_NO);
		} else {
			setTitle(MessageFormat.format(Messages.Title_edit, Messages.Step_step));
			if (CommonEnum.COMPLETE.equals(evaluationStep.getStepStatus())) {
				isInEvaluation = true;
			} else {
				isInEvaluation = evaluationStepService.isInEvaluationStep(tenderProjectEntity.getId(), evaluationStep.getId());
			}
		}
		refreshEvaluationStepForm();
	}
	
	/**
	 * @Description: 刷新评标步骤表单
	 * @author chenxw 
	 */
	private void refreshEvaluationStepForm() {
		stepNameText.setText(ObjectUtils.getObjString(evaluationStep.getStepName()));
		stepNameText.setEnabled(!isInEvaluation);
		
		WidgetUtils.setRadioChecked(roleTypeComposite, ObjectUtils.getObjString(evaluationStep.getRoleType()), "roleType");
		roleTypeComposite.setEnabled(!isInEvaluation);
		
		stepMemoText.setText(ObjectUtils.getObjString(evaluationStep.getStepMemo()));
		stepMemoText.setEnabled(!isInEvaluation);
		
		save_btn.setEnabled(!isInEvaluation);
	}
	
	/**
	 * @Description: 确定
	 * @author chenxw 
	 */
	private void saveEvaluationStepAction() {
		if (!save_btn.getEnabled()) return;
		if (!ValidateUtils.checkInput(stepNameText.getParent())) return;
		
		// 验证评标步骤名称是否已经存在
		String stepName = stepNameText.getText().trim();
		
		if (evaluationStepService.valEvaluationStepNameExist(tenderProjectEntity.getId(), evaluationStep.getId(), stepName)) {
			MessageDialog.openWarning(getShell(), Messages.Step_step + "[" + stepName + "]" + Messages.Tips_AlreadyExistsPleaseRetype);
			stepNameText.setFocus();
			stepNameText.setSelection(stepNameText.getText().length());
			return;
		}
		
		evaluationStep.setStepName(stepName);
		evaluationStep.setStepMemo(stepMemoText.getText().trim());
		evaluationStep.setRoleType(ObjectUtils.getObjString(WidgetUtils.getRadioVal(roleTypeComposite, "roleType")));
		
		evaluationStep = evaluationStepService.saveEvaluationStep(evaluationStep);
		if (null == evaluationStep) {
			MessageDialog.openWarning(getShell(), stepNameText.getText() + Messages.Tips_saveFail);
			return;
		}
		if (null != callBack) callBack.callBackObject(evaluationStep);
		this.getShell().close();
	}
	
	/**
	 * @Description: 取消
	 * @author guoyr
	 */
	private void cancelAction() {
		this.getShell().close();
	}
	
	public void setCallBack(CallBack callBack) {
		this.callBack = callBack;
	}
	
	/**
	 * Return the initial size of the dialog.
	 */
	@Override
	protected Point getInitialSize() {
		return new Point(650, 500);
	}
}
