package com.gx.obe.evaluation.step.form;

import java.text.MessageFormat;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.CallBack;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.core.listener.TextHintListener;
import org.eclipse.swt.core.listener.VerifyRequiredListener;
import org.eclipse.swt.core.utils.ValidateUtils;
import org.eclipse.swt.core.utils.WidgetUtils;
import org.eclipse.swt.core.widgets.EButton;
import org.eclipse.swt.core.widgets.EDialog;
import org.eclipse.swt.core.widgets.ESepator;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import com.gx.obe.ColorConstants;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.common.widget.button.Tips;
import com.gx.obe.components.core.I18NEnum;
import com.gx.obe.components.core.enumeration.CommonEnum;
import com.gx.obe.components.core.enumeration.EvaluationFactorEnum;
import com.gx.obe.components.core.enumeration.EvaluationStepEnum;
import com.gx.obe.config.utils.PropertiesUtils;
import com.gx.obe.message.Messages;
import com.gx.obe.util.utils.LogUtils;
import com.gx.obe.util.utils.ObjectUtils;
import com.gx.obe.web.entity.evaluation.EvaluationStep;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.service.evaluation.EvaluationStepService;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

/** 
 * @Description: 核量评审
 * @author chenxw 
 */
public class TotalPriceEvaluationStepDialog extends EDialog {
	
	private Text stepNameText;
	private EButton save_btn;
	private EvaluationStepService evaluationStepService = new EvaluationStepService();
	private TenderProjectEntity tenderProjectEntity;
	private EvaluationStep evaluationStep;
	private Text stepMemoText;
	private Composite composite;
	private CallBack callBack;
	private Tips messageRabel;
	private Label scoreAndWeight;
	private Composite roleTypeComposite;
	private Button allowEditPriceBtn;
	
	{
		LogUtils.logClass(TotalPriceEvaluationStepDialog.class);
	}
	
	/**
	 * Create the dialog.
	 * 
	 * @param parentShell
	 */
	public TotalPriceEvaluationStepDialog(Shell parentShell, TenderProjectEntity tenderProjectEntity, EvaluationStep evaluationStep) {
		super(parentShell);
		this.tenderProjectEntity = tenderProjectEntity;
		this.evaluationStep = evaluationStep;
	}
	
	/**
	 * Create contents of the dialog.
	 * 
	 * @param parent
	 */
	@Override
	protected Control createDialogArea(Composite parent) {
		Composite topContainer = (Composite) super.createDialogArea(parent);
		topContainer.addDisposeListener(new DisposeListener() {
			public void widgetDisposed(DisposeEvent e) {}
		});
		GridLayout gl_topContainer = new GridLayout(1, false);
		gl_topContainer.verticalSpacing = 0;
		gl_topContainer.horizontalSpacing = 0;
		gl_topContainer.marginHeight = 0;
		gl_topContainer.marginWidth = 0;
		topContainer.setLayout(gl_topContainer);
		
		Composite container = new Composite(topContainer, SWT.NONE);
		container.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		GridLayout gl_container = new GridLayout(1, false);
		gl_container.marginHeight = 10;
		gl_container.marginWidth = 10;
		container.setLayout(gl_container);
		this.setOperator(SWT.MAX | SWT.CLOSE);
		
		messageRabel = new Tips(container, SWT.WRAP);
		messageRabel.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 2, 1));
		messageRabel.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, EvaluationStepEnum.getEvaluationStepIco(EvaluationStepEnum.TOTAL_PRICE)));
		messageRabel.setSurroundColor(SWTResourceManager.getColor(60, 138, 226));
		
		composite = new Composite(container, SWT.NONE);
		GridLayout gl_composite = new GridLayout(2, false);
		gl_composite.marginWidth = 0;
		composite.setLayout(gl_composite);
		GridData gd_composite = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1);
		gd_composite.widthHint = 414;
		composite.setLayoutData(gd_composite);
		
		Label label = new Label(composite, SWT.NONE);
		label.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		label.setText(Messages.StepName + ": ");
		
		Composite composite_2 = new Composite(composite, SWT.NONE);
		composite_2.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		GridLayout gl_composite_2 = new GridLayout(2, false);
		gl_composite_2.marginWidth = 0;
		gl_composite_2.verticalSpacing = 1;
		gl_composite_2.marginHeight = 0;
		composite_2.setLayout(gl_composite_2);
		
		stepNameText = new Text(composite_2, SWT.NONE);
		stepNameText.setFont(SWTResourceManager.getFont("微软雅黑", 9, SWT.NORMAL));
		stepNameText.setLayoutData(new GridData(SWT.FILL, SWT.BOTTOM, true, false, 1, 1));
		stepNameText.addPaintListener(new TextHintListener(Messages.Tips_EnterEvaluationStepName));
		stepNameText.addVerifyListener(new VerifyRequiredListener(stepNameText,  MessageFormat.format(Messages.Tips_required, Messages.StepName)));
		stepNameText.setTextLimit(20);
		
		scoreAndWeight = new Label(composite_2, SWT.NONE);
		scoreAndWeight.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		scoreAndWeight.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		scoreAndWeight.setText("");
		
		ESepator namSep = new ESepator(composite_2, SWT.NONE);
		namSep.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 2, 1));
		namSep.setBackground(ColorConstants.SEP_LIGHT_COLOR);
		
		Label label_1 = new Label(composite, SWT.NONE);
		label_1.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		label_1.setText(Messages.EvaluationMembers + "：");
		
		Composite composite_6 = new Composite(composite, SWT.NONE);
		composite_6.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		GridLayout gl_composite_6 = new GridLayout(1, false);
		gl_composite_6.marginHeight = 0;
		gl_composite_6.verticalSpacing = 1;
		gl_composite_6.marginWidth = 0;
		composite_6.setLayout(gl_composite_6);
		
		roleTypeComposite = new Composite(composite_6, SWT.NONE);
		roleTypeComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		GridLayout gl_roleTypeComposite = new GridLayout(2, false);
		gl_roleTypeComposite.marginHeight = 0;
		gl_roleTypeComposite.marginWidth = 0;
		roleTypeComposite.setLayout(gl_roleTypeComposite);
		
		Button button = new Button(roleTypeComposite, SWT.RADIO);
		button.setText(Messages.ExpertLeader);
		button.setData("roleType", EvaluationStepEnum.EXPERT_LEADER);
		button.setSelection(true);
		
		Button button_1 = new Button(roleTypeComposite, SWT.RADIO);
		button_1.setText(Messages.ProjectManager);
		button_1.setData("roleType", EvaluationStepEnum.OPERATOR);
		
		Label label_2 = new Label(composite, SWT.NONE);
		label_2.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		label_2.setText(Messages.EvaluationSet + "：");
		
		allowEditPriceBtn = new Button(composite, SWT.CHECK);
		allowEditPriceBtn.setText(Messages.AllowChangePrice);
		
		Label label_5 = new Label(composite, SWT.NONE);
		label_5.setLayoutData(new GridData(SWT.RIGHT, SWT.TOP, false, true, 1, 1));
		label_5.setText(Messages.NodeNote + "：");
		
		stepMemoText = new Text(composite, SWT.BORDER | SWT.WRAP | SWT.V_SCROLL);
		stepMemoText.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		stepMemoText.setTextLimit(100);
		
		ESepator but_sep = new ESepator(topContainer, SWT.SEPARATOR | SWT.HORIZONTAL);
		but_sep.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		but_sep.setBackground(ColorConstants.SEP_LIGHT_COLOR);
		
		Composite composite_1 = new Composite(topContainer, SWT.NONE);
		composite_1.setBackgroundMode(SWT.INHERIT_FORCE);
		composite_1.setBackgroundImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/fill_bg.png"));
		composite_1.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 3, 1));
		GridLayout gl_composite_1 = new GridLayout(2, false);
		composite_1.setLayout(gl_composite_1);
		
		save_btn = new EButton(composite_1, SWT.NONE);
		save_btn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/save.png"));
		GridData gd_confirmBtn = new GridData(SWT.RIGHT, SWT.CENTER, true, false, 1, 1);
		gd_confirmBtn.widthHint = 90;
		save_btn.setLayoutData(gd_confirmBtn);
		save_btn.setText(Messages.Button_save);
		save_btn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				saveNodeAction();
			}
		});
		EButton cancel_btn = new EButton(composite_1, SWT.NONE);
		cancel_btn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/close.png"));
		cancel_btn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				cancelAction();
			}
		});
		GridData gd_button = new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1);
		gd_button.widthHint = 90;
		cancel_btn.setLayoutData(gd_button);
		cancel_btn.setText(Messages.Button_close);
		
		init();
		return container;
	}
	
	/**
	 * @Description: 初始化
	 * @author chenxw 
	 */
	private void init() {
		String supplierName = com.gx.obe.components.core.I18N.getString(I18NEnum.SUPPLIERNAME, tenderProjectEntity.getTenderType());
		messageRabel.setText(Messages.For + " " + supplierName + " " + Messages.ValidationQuotationLists);
		if (null == evaluationStep) {
			evaluationStep = new EvaluationStep();
			evaluationStep.setStepName(PropertiesUtils.getEnum(I18NEnum.CHECK_PRICE_EVALUATION, "报价核量评审"));
			evaluationStep.setStepType(EvaluationStepEnum.TOTAL_PRICE);
			evaluationStep.setFilterType(EvaluationStepEnum.FILTER_YES);
			evaluationStep.setStepStatus(CommonEnum.NOT_START);
			evaluationStep.setTenderId(tenderProjectEntity.getId());
			evaluationStep.setSortNo(evaluationStepService.getMaxEvaluationStepSortNo(tenderProjectEntity.getId()) + 1);
			this.setTitle(MessageFormat.format(Messages.Title_create, Messages.Step_step));
		} else {
			this.setTitle(MessageFormat.format(Messages.Title_edit, Messages.Step_step));
			boolean isInEvaluation = false;
			if(ObjectUtils.equals(evaluationStep.getStepStatus(), CommonEnum.COMPLETE)){
				composite.setEnabled(false);
				save_btn.setEnabled(false);
				isInEvaluation = true;
			}else {
				isInEvaluation = evaluationStepService.isInEvaluationStep(tenderProjectEntity.getId(), evaluationStep.getId());
			}
			if(isInEvaluation){
				roleTypeComposite.setEnabled(false);
			}
		}
		stepNameText.setText(ObjectUtils.getObjString(evaluationStep.getStepName()));
		stepMemoText.setText(ObjectUtils.getObjString(evaluationStep.getStepMemo()));
		allowEditPriceBtn.setSelection(evaluationStep.getEvaluationParamByKey(EvaluationStepEnum.ALLOW_EDIT_PRICE, Boolean.class));
		WidgetUtils.setRadioChecked(roleTypeComposite, evaluationStep.getRoleType(), "roleType");
		
	}
	
	/**
	 * @Description: 确定
	 * @author chenxw
	 */
	private void saveNodeAction() {
		if (!save_btn.getEnabled()) {
			return;
		}
		if (!ValidateUtils.checkInput(stepNameText.getParent())) {
			return;
		}
		// 验证评标步骤名称是否已经存在
		if (evaluationStepService.valEvaluationStepNameExist(tenderProjectEntity.getId(), evaluationStep.getId(), stepNameText.getText().trim())) {
			MessageDialog.openWarning(getShell(), Messages.Step_step  + "[" + stepNameText.getText().trim() + "]" + Messages.Tips_AlreadyExistsPleaseRetype);
			stepNameText.setFocus();
			stepNameText.setSelection(stepNameText.getText().length());
			return;
		}
		evaluationStep.setStepName(stepNameText.getText().trim());
		evaluationStep.setStepMemo(stepMemoText.getText().trim());
		evaluationStep.setRoleType(ObjectUtils.getObjString(WidgetUtils.getRadioVal(roleTypeComposite, "roleType")));
		evaluationStep.setEvaluationParam(EvaluationStepEnum.ALLOW_EDIT_PRICE, allowEditPriceBtn.getSelection() ? "true" : "false");
		evaluationStep.setEvalBidType(EvaluationFactorEnum.EVAL_BID_PRICE);
		evaluationStep = evaluationStepService.saveEvaluationStep(evaluationStep);
		
		if (null == evaluationStep) {
			MessageDialog.openWarning(getShell(), stepNameText.getText() + Messages.Tips_saveFail);
			return;
		}
		if (null != callBack) {
			callBack.callBackObject(evaluationStep);
		}
		this.getShell().close();
		
	}
	
	/**
	 * @Description: 取消
	 * @author chenxw 
	 */
	private void cancelAction() {
		this.getShell().close();
	}
	
	public void setCallBack(CallBack callBack) {
		this.callBack = callBack;
	}
	
	/**
	 * Return the initial size of the dialog.
	 */
	@Override
	protected Point getInitialSize() {
		return new Point(600, 400);
	}
}
