package com.gx.obe.evaluation.step.inter;

import java.util.List;

import org.eclipse.nebula.widgets.grid.Grid;

import com.gx.obe.business.entity.Worker;
import com.gx.obe.web.entity.expert.Expert;

/**
 * @Description:
 * @author chenxw
 */
public interface IEvaluationGroup {
	
	/**
	 * @Description: 初始化
	 * @author chenxw
	 */
	void initEvaluationGroupGrid(Grid grid);
	
	/**
	 * @Description: 刷新
	 * @author chenxw
	 */
	void refreshEvaluationGroupGrid(Grid grid);
	
	/**
	 * @Description: 添加评审分组
	 * @author chenxw
	 * @param supplierIdList
	 * @param evalBidType
	 * @param userId
	 */
	void putAllGroupTypeMapSupplierMap(List<String> supplierIdList, String evalBidType, String userId);
	
	/**
	 * @Description: 获取投标人名称
	 * @author chenxw
	 * @return
	 */
	String getSupplierName();
	
	/**
	 * @Description: 获取专家列表
	 * @author chenxw
	 * @return
	 */
	List<Expert> getExpertList();
	
	/**
	 * @Description: 获取工作人员列表
	 * @author chenxw
	 * @return
	 */
	List<Worker> getWorkerList();
}
