package com.gx.obe.evaluation.step.inter;

import java.util.List;

import com.gx.obe.evaluation.step.listener.EvaluationSupplierFactorListener;
import com.gx.obe.web.entity.Supplier;
import com.gx.obe.web.entity.auth.AuthUser;
import com.gx.obe.web.entity.evaluation.EvaluationStep;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.entity.tender.TenderProjectRuleEntity;


public interface IEvaluationTable{
	
	/**
	 * @Description: 刷新评标界面
	 * @author guoyr
	 * @param tenderProject
	 * @param projectRule
	 * @param user
	 * @param evaluationStep
	 * @param supplierList
	 * @param evaluationSupplierFactorListener 
	 */
	public void refresh(TenderProjectEntity tenderProject, TenderProjectRuleEntity projectRule, AuthUser user, EvaluationStep evaluationStep, List<Supplier> supplierList, EvaluationSupplierFactorListener evaluationSupplierFactorListener);
	
	/**
	 * @Description: 设置表格中的字体大小
	 * @author guoyr
	 * @param fontSize 
	 */
	public void setTableFontSize(int fontSize);
	
	
	/**
	 * @Description: 设置默认指标结果
	 * @author guoyr 
	 */
	public void initDefaultFactorResult();
	
	/**
	 * @Description: 导入其他专家的评审结果
	 * @author guoyr 
	 */
	public void importOtherExpertResult();
	
	
	/**
	 * @Description: 导入历史评审结果
	 * @author guoyr 
	 */
	public void importHistoryResult();
	
	/**
	 * @Description: 切换坐标
	 * @author guoyr 
	 */
	public void switchCoordinateAction();
	
	/**
	 * @Description: 保存评标结果
	 * @author guoyr
	 * @return 
	 */
	public boolean saveEvaluationFactorResult();
	
	/**
	 * @Description: 检查是否可以提交
	 * @author guoyr
	 * @return 
	 */
	public String checkSubmit();
	
	/**
	 * @Description: 提交评标结果
	 * @author guoyr
	 * @return 
	 */
	public boolean submitEvaluationFactorResult();
	
	/**
	 * @Description: 关闭编辑器
	 * @author guoyr 
	 */
	public void closeCellEditor();
	
	public void resizeColumn(int width);

	/**
	 * @Description: 检查是否刷新
	 * @author chenxw
	 * @return 
	 */
	public boolean checkRefresh();

}
