package com.gx.obe.evaluation.step.review.action;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Composite;

import com.gx.obe.action.bean.Action;
import com.gx.obe.action.listener.ActionListener;
import com.gx.obe.evaluation.step.listener.ExpertEvaluationListener;
import com.gx.obe.evaluation.step.review.composite.BusinessEvaluationComposite;

/**
 * @Description: 商务评审事件
 * @author chenxw
 */
public class BusinessEvaluationAction extends Action {
	
	public void run() {
		ActionListener actionListener = this.getListener();
		if (null == actionListener) {
			return;
		}
		actionListener.onLoad(this);
		Composite parentComposite = actionListener.getParentComposite();
		parentComposite.setData("tenderProject", this.getTenderProject());
		parentComposite.setData("evaluationStep", this.getData("evaluationStep"));
		parentComposite.setData("projectRule", this.getData("tenderProjectRuleEntity"));
		parentComposite.setData("hideLeft", this.getData("hideLeft"));
		BusinessEvaluationComposite composite = new BusinessEvaluationComposite(parentComposite, SWT.NONE);
		actionListener.loadComposite(this, composite);
		composite.addExpertEvaluationListener((ExpertEvaluationListener) this.getData("expertEvaluationListener"));
	}
	
}
