package com.gx.obe.evaluation.step.widgets;

import java.text.MessageFormat;

import org.eclipse.swt.graphics.Image;

import com.gx.obe.message.Messages;
import com.swtdesigner.ResourceManager;

public enum LeftMenuEnum {
	
	/**
	 * 只显示投标文件
	 */
	BID_FILE_ONLY(Messages.Tips_viewBidFiles, ResourceManager.getPluginImage("com.gx.obe.evaluation", "icons/bid_file.png")), 
	
	/**
	 * 招标文件和投标文件左右显示
	 */
	BIDDING_BID_FILE_BOTH_HOR(Messages.Tips_viewFilesBothHor, ResourceManager.getPluginImage("com.gx.obe.evaluation", "icons/bidding_bid_hor.png")),
	/**
	 * 招标文件和投标文件上下显示
	 */
	BIDDING_BID_FILE_BOTH_VER(Messages.Tips_viewFilesBothVer, ResourceManager.getPluginImage("com.gx.obe.evaluation", "icons/bidding_bid.png")),
	/**
	 * 只显示招标文件
	 */
	BIDDING_FILE_ONLY(Messages.Tips_viewBiddingFiles, ResourceManager.getPluginImage("com.gx.obe.evaluation", "icons/bidding.png")),
	/**
	 * 查看标书清标意见
	 */
	VIEW_BID_FILE_OPINION(MessageFormat.format(Messages.Title_view, Messages.Button_bidFileOpinion), ResourceManager.getPluginImage("com.gx.obe.evaluation", "icons/file_search.png")),
	/**
	 * 查看指标评审意见
	 */
	VIEW_FACTOR_EVAL_OPINION(MessageFormat.format(Messages.Title_view, Messages.Button_factorOpinion), ResourceManager.getPluginImage("com.gx.obe.evaluation", "icons/eval_opinion.png")),
	/**
	 * 查看天眼查征信
	 */
	VIEW_CREDIT_TYC("天眼查", ResourceManager.getPluginImage("com.gx.obe.evaluation", "icons/credit.png")),
	/**
	 * 查看中数智慧征信
	 */
	VIEW_CREDIT_ZSZH("中数智汇", ResourceManager.getPluginImage("com.gx.obe.evaluation", "icons/credit.png")),
	/**
	 * 全屏显示文件面板
	 */
	SHOW_FILE_ONLY(Messages.Tips_viewFullFiles, ResourceManager.getPluginImage("com.gx.obe.evaluation", "icons/file_panel.png")), 
	
	/**
	 * 上下显示文件面板和评审面板
	 */
	FILE_EVAL_VER(Messages.Tips_viewFileEvaluationVer, ResourceManager.getPluginImage("com.gx.obe.evaluation", "icons/file_eval.png")),
	/**
	 * 左右显示文件面板和评审面板
	 */
	FILE_EVAL_HOR(Messages.Tips_viewFileEvaluationHor, ResourceManager.getPluginImage("com.gx.obe.evaluation", "icons/file_eval_hor.png")),
	/**
	 * 全屏显示评审面板
	 */
	SHOW_EVALUATION_ONLY(Messages.Tips_viewFullEvaluationPanel, ResourceManager.getPluginImage("com.gx.obe.evaluation", "icons/eval_panel.png")),
	
	/**
	 * 澄清答疑内容
	 */
	CLARIFY_ANSWER_CONTENT(MessageFormat.format(Messages.Button_addToFormat, Messages.ClarificationAnswerContent), ResourceManager.getPluginImage("com.gx.obe.evaluation", "icons/clarification.png")),
	
	/**
	 * 澄清答疑文件
	 */
	CLARIFY_ANSWER_DOCUMENTS(MessageFormat.format(Messages.Button_sendFormat, Messages.ClarificationAnswerDocuments), ResourceManager.getPluginImage("com.gx.obe.evaluation", "icons/clairfy_queswer.png"));
	
	String title;
	Image image;
	LeftMenuEnum(String title, Image image) {
		this.title = title;
		this.image = image;
	}
	public String getTitle() {
		return title;
	}
	public Image getImage() {
		return image;
	}
	public void setImage(Image image) {
		this.image = image;
	}
	
}
